<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="fr" xml:lang="fr"><head>

<meta charset="utf-8">
<meta name="generator" content="quarto-1.5.47">

<meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes">

<meta name="description" content="Introduction à l’analyse de réseau avec R">

<title>3&nbsp; Mesures locales – Analyse de réseau avec `igraph`</title>
<style>
code{white-space: pre-wrap;}
span.smallcaps{font-variant: small-caps;}
div.columns{display: flex; gap: min(4vw, 1.5em);}
div.column{flex: auto; overflow-x: auto;}
div.hanging-indent{margin-left: 1.5em; text-indent: -1.5em;}
ul.task-list{list-style: none;}
ul.task-list li input[type="checkbox"] {
  width: 0.8em;
  margin: 0 0.8em 0.2em -1em; /* quarto-specific, see https://github.com/quarto-dev/quarto-cli/issues/4556 */ 
  vertical-align: middle;
}
/* CSS for syntax highlighting */
pre > code.sourceCode { white-space: pre; position: relative; }
pre > code.sourceCode > span { line-height: 1.25; }
pre > code.sourceCode > span:empty { height: 1.2em; }
.sourceCode { overflow: visible; }
code.sourceCode > span { color: inherit; text-decoration: inherit; }
div.sourceCode { margin: 1em 0; }
pre.sourceCode { margin: 0; }
@media screen {
div.sourceCode { overflow: auto; }
}
@media print {
pre > code.sourceCode { white-space: pre-wrap; }
pre > code.sourceCode > span { display: inline-block; text-indent: -5em; padding-left: 5em; }
}
pre.numberSource code
  { counter-reset: source-line 0; }
pre.numberSource code > span
  { position: relative; left: -4em; counter-increment: source-line; }
pre.numberSource code > span > a:first-child::before
  { content: counter(source-line);
    position: relative; left: -1em; text-align: right; vertical-align: baseline;
    border: none; display: inline-block;
    -webkit-touch-callout: none; -webkit-user-select: none;
    -khtml-user-select: none; -moz-user-select: none;
    -ms-user-select: none; user-select: none;
    padding: 0 4px; width: 4em;
  }
pre.numberSource { margin-left: 3em;  padding-left: 4px; }
div.sourceCode
  {   }
@media screen {
pre > code.sourceCode > span > a:first-child::before { text-decoration: underline; }
}
</style>


<script src="site_libs/quarto-nav/quarto-nav.js"></script>
<script src="site_libs/quarto-nav/headroom.min.js"></script>
<script src="site_libs/clipboard/clipboard.min.js"></script>
<script src="site_libs/quarto-search/autocomplete.umd.js"></script>
<script src="site_libs/quarto-search/fuse.min.js"></script>
<script src="site_libs/quarto-search/quarto-search.js"></script>
<meta name="quarto:offset" content="./">
<link href="./communaute.html" rel="next">
<link href="./indicateurs.html" rel="prev">
<link href="./cover.png" rel="icon" type="image/png">
<script src="site_libs/quarto-html/quarto.js"></script>
<script src="site_libs/quarto-html/popper.min.js"></script>
<script src="site_libs/quarto-html/tippy.umd.min.js"></script>
<script src="site_libs/quarto-html/anchor.min.js"></script>
<link href="site_libs/quarto-html/tippy.css" rel="stylesheet">
<link href="site_libs/quarto-html/quarto-syntax-highlighting.css" rel="stylesheet" id="quarto-text-highlighting-styles">
<script src="site_libs/bootstrap/bootstrap.min.js"></script>
<link href="site_libs/bootstrap/bootstrap-icons.css" rel="stylesheet">
<link href="site_libs/bootstrap/bootstrap.min.css" rel="stylesheet" id="quarto-bootstrap" data-mode="light">
<script id="quarto-search-options" type="application/json">{
  "location": "sidebar",
  "copy-button": false,
  "collapse-after": 3,
  "panel-placement": "start",
  "type": "textbox",
  "limit": 50,
  "keyboard-shortcut": [
    "f",
    "/",
    "s"
  ],
  "show-item-context": false,
  "language": {
    "search-no-results-text": "Pas de résultats",
    "search-matching-documents-text": "documents trouvés",
    "search-copy-link-title": "Copier le lien vers la recherche",
    "search-hide-matches-text": "Cacher les correspondances additionnelles",
    "search-more-match-text": "correspondance de plus dans ce document",
    "search-more-matches-text": "correspondances de plus dans ce document",
    "search-clear-button-title": "Effacer",
    "search-text-placeholder": "",
    "search-detached-cancel-button-title": "Annuler",
    "search-submit-button-title": "Envoyer",
    "search-label": "Recherche"
  }
}</script>
<link href="site_libs/htmltools-fill-0.5.8.1/fill.css" rel="stylesheet">
<script src="site_libs/htmlwidgets-1.6.4/htmlwidgets.js"></script>
<link href="site_libs/datatables-css-0.0.0/datatables-crosstalk.css" rel="stylesheet">
<script src="site_libs/datatables-binding-0.33/datatables.js"></script>
<script src="site_libs/jquery-3.6.0/jquery-3.6.0.min.js"></script>
<link href="site_libs/dt-core-1.13.6/css/jquery.dataTables.min.css" rel="stylesheet">
<link href="site_libs/dt-core-1.13.6/css/jquery.dataTables.extra.css" rel="stylesheet">
<script src="site_libs/dt-core-1.13.6/js/jquery.dataTables.min.js"></script>
<link href="site_libs/crosstalk-1.2.1/css/crosstalk.min.css" rel="stylesheet">
<script src="site_libs/crosstalk-1.2.1/js/crosstalk.min.js"></script>


<meta property="og:title" content="3&nbsp; Mesures locales – Analyse de réseau avec igraph">
<meta property="og:description" content="Introduction à l’analyse de réseau avec R">
<meta property="og:site_name" content="Analyse de réseau avec `igraph`">
</head>

<body class="nav-sidebar floating">

<div id="quarto-search-results"></div>
  <header id="quarto-header" class="headroom fixed-top">
  <nav class="quarto-secondary-nav">
    <div class="container-fluid d-flex">
      <button type="button" class="quarto-btn-toggle btn" data-bs-toggle="collapse" role="button" data-bs-target=".quarto-sidebar-collapse-item" aria-controls="quarto-sidebar" aria-expanded="false" aria-label="Basculer la barre latérale" onclick="if (window.quartoToggleHeadroom) { window.quartoToggleHeadroom(); }">
        <i class="bi bi-layout-text-sidebar-reverse"></i>
      </button>
        <nav class="quarto-page-breadcrumbs" aria-label="breadcrumb"><ol class="breadcrumb"><li class="breadcrumb-item"><a href="./mesures.html"><span class="chapter-number">3</span>&nbsp; <span class="chapter-title">Mesures locales</span></a></li></ol></nav>
        <a class="flex-grow-1" role="navigation" data-bs-toggle="collapse" data-bs-target=".quarto-sidebar-collapse-item" aria-controls="quarto-sidebar" aria-expanded="false" aria-label="Basculer la barre latérale" onclick="if (window.quartoToggleHeadroom) { window.quartoToggleHeadroom(); }">      
        </a>
      <button type="button" class="btn quarto-search-button" aria-label="Recherche" onclick="window.quartoOpenSearch();">
        <i class="bi bi-search"></i>
      </button>
    </div>
  </nav>
</header>
<!-- content -->
<div id="quarto-content" class="quarto-container page-columns page-rows-contents page-layout-article">
<!-- sidebar -->
  <nav id="quarto-sidebar" class="sidebar collapse collapse-horizontal quarto-sidebar-collapse-item sidebar-navigation floating overflow-auto">
    <div class="pt-lg-2 mt-2 text-left sidebar-header">
    <div class="sidebar-title mb-0 py-0">
      <a href="./">Analyse de réseau avec <code>igraph</code></a> 
    </div>
      </div>
        <div class="mt-2 flex-shrink-0 align-items-center">
        <div class="sidebar-search">
        <div id="quarto-search" class="" title="Recherche"></div>
        </div>
        </div>
    <div class="sidebar-menu-container"> 
    <ul class="list-unstyled mt-1">
        <li class="sidebar-item">
  <div class="sidebar-item-container"> 
  <a href="./index.html" class="sidebar-item-text sidebar-link">
 <span class="menu-text">Le package <code>igraph</code></span></a>
  </div>
</li>
        <li class="sidebar-item">
  <div class="sidebar-item-container"> 
  <a href="./igraph.html" class="sidebar-item-text sidebar-link">
 <span class="menu-text"><span class="chapter-number">1</span>&nbsp; <span class="chapter-title">L’objet <code>igraph</code></span></span></a>
  </div>
</li>
        <li class="sidebar-item">
  <div class="sidebar-item-container"> 
  <a href="./indicateurs.html" class="sidebar-item-text sidebar-link">
 <span class="menu-text"><span class="chapter-number">2</span>&nbsp; <span class="chapter-title">Indicateurs globaux</span></span></a>
  </div>
</li>
        <li class="sidebar-item">
  <div class="sidebar-item-container"> 
  <a href="./mesures.html" class="sidebar-item-text sidebar-link active">
 <span class="menu-text"><span class="chapter-number">3</span>&nbsp; <span class="chapter-title">Mesures locales</span></span></a>
  </div>
</li>
        <li class="sidebar-item">
  <div class="sidebar-item-container"> 
  <a href="./communaute.html" class="sidebar-item-text sidebar-link">
 <span class="menu-text"><span class="chapter-number">4</span>&nbsp; <span class="chapter-title">Cliques et communautés</span></span></a>
  </div>
</li>
        <li class="sidebar-item">
  <div class="sidebar-item-container"> 
  <a href="./graphique.html" class="sidebar-item-text sidebar-link">
 <span class="menu-text"><span class="chapter-number">5</span>&nbsp; <span class="chapter-title">Représentation graphique</span></span></a>
  </div>
</li>
        <li class="sidebar-item">
  <div class="sidebar-item-container"> 
  <a href="./conclusion.html" class="sidebar-item-text sidebar-link">
 <span class="menu-text">Conclusion</span></a>
  </div>
</li>
        <li class="sidebar-item">
  <div class="sidebar-item-container"> 
  <a href="./exercice.html" class="sidebar-item-text sidebar-link">
 <span class="menu-text">Exercice</span></a>
  </div>
</li>
        <li class="sidebar-item">
  <div class="sidebar-item-container"> 
  <a href="./references.html" class="sidebar-item-text sidebar-link">
 <span class="menu-text">Références</span></a>
  </div>
</li>
    </ul>
    </div>
</nav>
<div id="quarto-sidebar-glass" class="quarto-sidebar-collapse-item" data-bs-toggle="collapse" data-bs-target=".quarto-sidebar-collapse-item"></div>
<!-- margin-sidebar -->
    <div id="quarto-margin-sidebar" class="sidebar margin-sidebar">
        <nav id="TOC" role="doc-toc" class="toc-active">
    <h2 id="toc-title">Table des matières</h2>
   
  <ul>
  <li><a href="#centralité-de-degré" id="toc-centralité-de-degré" class="nav-link active" data-scroll-target="#centralité-de-degré"><span class="header-section-number">3.1</span> Centralité de degré</a>
  <ul class="collapse">
  <li><a href="#degré-normalisé" id="toc-degré-normalisé" class="nav-link" data-scroll-target="#degré-normalisé"><span class="header-section-number">3.1.1</span> Degré normalisé</a></li>
  <li><a href="#degré-pondéré" id="toc-degré-pondéré" class="nav-link" data-scroll-target="#degré-pondéré"><span class="header-section-number">3.1.2</span> Degré pondéré</a></li>
  </ul></li>
  <li><a href="#distribution-des-degrés" id="toc-distribution-des-degrés" class="nav-link" data-scroll-target="#distribution-des-degrés"><span class="header-section-number">3.2</span> Distribution des degrés</a></li>
  <li><a href="#les-sommets-voisins" id="toc-les-sommets-voisins" class="nav-link" data-scroll-target="#les-sommets-voisins"><span class="header-section-number">3.3</span> Les sommets voisins</a></li>
  <li><a href="#centralité-dintermédiarité" id="toc-centralité-dintermédiarité" class="nav-link" data-scroll-target="#centralité-dintermédiarité"><span class="header-section-number">3.4</span> Centralité d’intermédiarité</a></li>
  <li><a href="#centralité-de-proximité" id="toc-centralité-de-proximité" class="nav-link" data-scroll-target="#centralité-de-proximité"><span class="header-section-number">3.5</span> Centralité de proximité</a></li>
  <li><a href="#transitivité-locale" id="toc-transitivité-locale" class="nav-link" data-scroll-target="#transitivité-locale"><span class="header-section-number">3.6</span> Transitivité locale</a></li>
  <li><a href="#relations-entre-indicateurs" id="toc-relations-entre-indicateurs" class="nav-link" data-scroll-target="#relations-entre-indicateurs"><span class="header-section-number">3.7</span> Relations entre indicateurs</a></li>
  <li><a href="#les-mesures-comme-attributs" id="toc-les-mesures-comme-attributs" class="nav-link" data-scroll-target="#les-mesures-comme-attributs"><span class="header-section-number">3.8</span> Les mesures comme attributs</a></li>
  </ul>
</nav>
    </div>
<!-- main -->
<main class="content" id="quarto-document-content">

<header id="title-block-header" class="quarto-title-block default">
<div class="quarto-title">
<h1 class="title"><span class="chapter-number">3</span>&nbsp; <span class="chapter-title">Mesures locales</span></h1>
</div>



<div class="quarto-title-meta">

    
  
    
  </div>
  


</header>


<p>Les mesures disponibles sont nombreuses, nous avons listé ici les plus couramment employées.</p>
<section id="centralité-de-degré" class="level2" data-number="3.1">
<h2 data-number="3.1" class="anchored" data-anchor-id="centralité-de-degré"><span class="header-section-number">3.1</span> Centralité de degré</h2>
<p>Nombre de liens adjacents à un sommet.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb1"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb1-1"><a href="#cb1-1" aria-hidden="true" tabindex="-1"></a><span class="fu">degree</span>(karate)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>   Mr Hi  Actor 2  Actor 3  Actor 4  Actor 5  Actor 6  Actor 7  Actor 8 
      16        9       10        6        3        4        4        4 
 Actor 9 Actor 10 Actor 11 Actor 12 Actor 13 Actor 14 Actor 15 Actor 16 
       5        2        3        1        2        5        2        2 
Actor 17 Actor 18 Actor 19 Actor 20 Actor 21 Actor 22 Actor 23 Actor 24 
       2        2        2        3        2        2        2        5 
Actor 25 Actor 26 Actor 27 Actor 28 Actor 29 Actor 30 Actor 31 Actor 32 
       3        3        2        4        3        4        4        6 
Actor 33   John A 
      12       17 </code></pre>
</div>
</div>
<section id="degré-normalisé" class="level3" data-number="3.1.1">
<h3 data-number="3.1.1" class="anchored" data-anchor-id="degré-normalisé"><span class="header-section-number">3.1.1</span> Degré normalisé</h3>
<p>L’argument <code>normalized</code> permet de calculer la centralité de degré normalisée (<em>degré / (nombre de sommets-1)</em>). Quand on étudie un réseau orienté, l’argument <code>mode</code> permet de calculer le degré entrant (“in”), sortant (“out”) ou les deux (“all”).</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb3"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb3-1"><a href="#cb3-1" aria-hidden="true" tabindex="-1"></a><span class="fu">degree</span>(karate, <span class="at">normalized =</span> <span class="cn">TRUE</span>, <span class="at">mode =</span> <span class="st">"all"</span>)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>     Mr Hi    Actor 2    Actor 3    Actor 4    Actor 5    Actor 6    Actor 7 
0.48484848 0.27272727 0.30303030 0.18181818 0.09090909 0.12121212 0.12121212 
   Actor 8    Actor 9   Actor 10   Actor 11   Actor 12   Actor 13   Actor 14 
0.12121212 0.15151515 0.06060606 0.09090909 0.03030303 0.06060606 0.15151515 
  Actor 15   Actor 16   Actor 17   Actor 18   Actor 19   Actor 20   Actor 21 
0.06060606 0.06060606 0.06060606 0.06060606 0.06060606 0.09090909 0.06060606 
  Actor 22   Actor 23   Actor 24   Actor 25   Actor 26   Actor 27   Actor 28 
0.06060606 0.06060606 0.15151515 0.09090909 0.09090909 0.06060606 0.12121212 
  Actor 29   Actor 30   Actor 31   Actor 32   Actor 33     John A 
0.09090909 0.12121212 0.12121212 0.18181818 0.36363636 0.51515152 </code></pre>
</div>
</div>
</section>
<section id="degré-pondéré" class="level3" data-number="3.1.2">
<h3 data-number="3.1.2" class="anchored" data-anchor-id="degré-pondéré"><span class="header-section-number">3.1.2</span> Degré pondéré</h3>
<p>Degré pondéré par l’intensité des liens (attribut <em>weight</em>).</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb5"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb5-1"><a href="#cb5-1" aria-hidden="true" tabindex="-1"></a><span class="fu">strength</span>(karate)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>   Mr Hi  Actor 2  Actor 3  Actor 4  Actor 5  Actor 6  Actor 7  Actor 8 
      42       29       33       18        8       14       13       13 
 Actor 9 Actor 10 Actor 11 Actor 12 Actor 13 Actor 14 Actor 15 Actor 16 
      17        3        8        3        4       17        5        7 
Actor 17 Actor 18 Actor 19 Actor 20 Actor 21 Actor 22 Actor 23 Actor 24 
       6        3        3        5        4        4        5       21 
Actor 25 Actor 26 Actor 27 Actor 28 Actor 29 Actor 30 Actor 31 Actor 32 
       7       14        6       13        6       13       11       21 
Actor 33   John A 
      38       48 </code></pre>
</div>
</div>
</section>
</section>
<section id="distribution-des-degrés" class="level2" data-number="3.2">
<h2 data-number="3.2" class="anchored" data-anchor-id="distribution-des-degrés"><span class="header-section-number">3.2</span> Distribution des degrés</h2>
<p>La fonction <code>degree.distribution()</code> permet de calculer la fréquence relative des sommets par degré.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb7"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb7-1"><a href="#cb7-1" aria-hidden="true" tabindex="-1"></a><span class="co"># mode = c("all", "out", "in", "total")</span></span>
<span id="cb7-2"><a href="#cb7-2" aria-hidden="true" tabindex="-1"></a><span class="co"># loops = TRUE/FALSE</span></span>
<span id="cb7-3"><a href="#cb7-3" aria-hidden="true" tabindex="-1"></a><span class="co"># cumulative = TRUE/FALSE</span></span>
<span id="cb7-4"><a href="#cb7-4" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb7-5"><a href="#cb7-5" aria-hidden="true" tabindex="-1"></a><span class="fu">degree.distribution</span>(karate)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code> [1] 0.00000000 0.02941176 0.32352941 0.17647059 0.17647059 0.08823529
 [7] 0.05882353 0.00000000 0.00000000 0.02941176 0.02941176 0.00000000
[13] 0.02941176 0.00000000 0.00000000 0.00000000 0.02941176 0.02941176</code></pre>
</div>
</div>
<ul>
<li>1ère valeur = fréquence relative des sommets de degré 0</li>
<li>2ème valeur = fréquence relative des sommets de degré 1</li>
<li>…</li>
</ul>
<p>Représenter la distribution des degrés.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb9"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb9-1"><a href="#cb9-1" aria-hidden="true" tabindex="-1"></a><span class="fu">plot</span>(<span class="fu">degree.distribution</span>(karate), <span class="at">type=</span><span class="st">"b"</span>)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output-display">
<div>
<figure class="figure">
<p><img src="mesures_files/figure-html/unnamed-chunk-6-1.png" class="img-fluid figure-img" width="672"></p>
</figure>
</div>
</div>
</div>
<p>Aucun sommet ne présente un degré égal à 0, il n’y a donc aucun sommet isolé.</p>
<p><br>
</p>
</section>
<section id="les-sommets-voisins" class="level2" data-number="3.3">
<h2 data-number="3.3" class="anchored" data-anchor-id="les-sommets-voisins"><span class="header-section-number">3.3</span> Les sommets voisins</h2>
<p>Pour connaître les voisins d’un sommets, utiliser la fonction <code>neighbors()</code>.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb10"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb10-1"><a href="#cb10-1" aria-hidden="true" tabindex="-1"></a><span class="fu">neighbors</span>(karate, <span class="at">v =</span> <span class="dv">1</span>)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>+ 16/34 vertices, named, from 4b458a1:
 [1] Actor 2  Actor 3  Actor 4  Actor 5  Actor 6  Actor 7  Actor 8  Actor 9 
 [9] Actor 11 Actor 12 Actor 13 Actor 14 Actor 18 Actor 20 Actor 22 Actor 32</code></pre>
</div>
</div>
<p>Pour récupérer la liste des liens vers les sommets voisins, utiliser la fonction <code>incident()</code>.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb12"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb12-1"><a href="#cb12-1" aria-hidden="true" tabindex="-1"></a><span class="fu">incident</span>(karate, <span class="at">v =</span> <span class="dv">1</span>)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>+ 16/78 edges from 4b458a1 (vertex names):
 [1] Mr Hi--Actor 2  Mr Hi--Actor 3  Mr Hi--Actor 4  Mr Hi--Actor 5 
 [5] Mr Hi--Actor 6  Mr Hi--Actor 7  Mr Hi--Actor 8  Mr Hi--Actor 9 
 [9] Mr Hi--Actor 11 Mr Hi--Actor 12 Mr Hi--Actor 13 Mr Hi--Actor 14
[13] Mr Hi--Actor 18 Mr Hi--Actor 20 Mr Hi--Actor 22 Mr Hi--Actor 32</code></pre>
</div>
</div>
<p>Pour savoir si deux sommets sont connectés, utiliser la fonction <code>are.connected()</code>.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb14"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb14-1"><a href="#cb14-1" aria-hidden="true" tabindex="-1"></a><span class="fu">are.connected</span>(karate, <span class="at">v1 =</span> <span class="dv">1</span>, <span class="at">v2 =</span> <span class="dv">34</span>)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>[1] FALSE</code></pre>
</div>
</div>
<p><br>
</p>
</section>
<section id="centralité-dintermédiarité" class="level2" data-number="3.4">
<h2 data-number="3.4" class="anchored" data-anchor-id="centralité-dintermédiarité"><span class="header-section-number">3.4</span> Centralité d’intermédiarité</h2>
<p>Elle calcule la proportion de plus courts chemins passant par un sommet donné.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb16"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb16-1"><a href="#cb16-1" aria-hidden="true" tabindex="-1"></a><span class="fu">betweenness</span>(karate, <span class="at">weights =</span> <span class="cn">NULL</span>, <span class="at">normalized=</span><span class="cn">TRUE</span>, <span class="at">directed =</span> <span class="cn">FALSE</span>)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>       Mr Hi      Actor 2      Actor 3      Actor 4      Actor 5      Actor 6 
0.4737689394 0.0640151515 0.0694128788 0.0025252525 0.0009469697 0.0293560606 
     Actor 7      Actor 8      Actor 9     Actor 10     Actor 11     Actor 12 
0.0293560606 0.0000000000 0.0248106061 0.0137941919 0.0009469697 0.0000000000 
    Actor 13     Actor 14     Actor 15     Actor 16     Actor 17     Actor 18 
0.0000000000 0.0022727273 0.0000000000 0.0000000000 0.0000000000 0.0304924242 
    Actor 19     Actor 20     Actor 21     Actor 22     Actor 23     Actor 24 
0.0056818182 0.2406565657 0.0000000000 0.0000000000 0.0000000000 0.0018939394 
    Actor 25     Actor 26     Actor 27     Actor 28     Actor 29     Actor 30 
0.0640782828 0.0009469697 0.0000000000 0.0123106061 0.0191287879 0.0000000000 
    Actor 31     Actor 32     Actor 33       John A 
0.0056818182 0.1256313131 0.0722222222 0.3967803030 </code></pre>
</div>
</div>
<p>Les arguments <code>normalized</code> et <code>weights</code> permettent de normaliser ou non la centralité d’intermédiarité et d’utiliser ou non le poids des arêtes.</p>
<p><br>
</p>
</section>
<section id="centralité-de-proximité" class="level2" data-number="3.5">
<h2 data-number="3.5" class="anchored" data-anchor-id="centralité-de-proximité"><span class="header-section-number">3.5</span> Centralité de proximité</h2>
<p>Cet indicateur est l’inverse de la somme des distances des plus courts chemins d’un sommet vers tous les autres, il varie entre 0 et 1.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb18"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb18-1"><a href="#cb18-1" aria-hidden="true" tabindex="-1"></a><span class="fu">closeness</span>(karate, <span class="at">weights =</span> <span class="cn">NULL</span>, <span class="at">normalized=</span><span class="cn">TRUE</span>, <span class="at">mode =</span> <span class="st">"all"</span>)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>    Mr Hi   Actor 2   Actor 3   Actor 4   Actor 5   Actor 6   Actor 7   Actor 8 
0.2538462 0.2000000 0.1964286 0.1764706 0.1527778 0.1520737 0.1534884 0.1823204 
  Actor 9  Actor 10  Actor 11  Actor 12  Actor 13  Actor 14  Actor 15  Actor 16 
0.1987952 0.1907514 0.1755319 0.1460177 0.2049689 0.1907514 0.1709845 0.1375000 
 Actor 17  Actor 18  Actor 19  Actor 20  Actor 21  Actor 22  Actor 23  Actor 24 
0.1085526 0.1929825 0.1875000 0.2481203 0.2037037 0.1764706 0.1586538 0.1386555 
 Actor 25  Actor 26  Actor 27  Actor 28  Actor 29  Actor 30  Actor 31  Actor 32 
0.1578947 0.1235955 0.1692308 0.1563981 0.2024540 0.1746032 0.1736842 0.2088608 
 Actor 33    John A 
0.2000000 0.2519084 </code></pre>
</div>
</div>
<div class="callout callout-style-simple callout-note no-icon">
<div class="callout-body d-flex">
<div class="callout-icon-container">
<i class="callout-icon no-icon"></i>
</div>
<div class="callout-body-container">
<p><strong>A.</strong> Calculer les centralités sur chaque composante connexe.</p>
<p><strong>Si votre réseau n’est pas connexe, il est nécessaire d’utiliser la fonction <code>decompose</code> puis de mesurer les centralités d’intermédiarité et de proximité dans chaque composante</strong>. Sinon, le résultat fourni par <code>igraph</code> est aberrant ; attention, il n’y a ni warning ni message d’erreur…</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb20"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb20-1"><a href="#cb20-1" aria-hidden="true" tabindex="-1"></a><span class="fu">betweenness</span>(Mes_composantes[[<span class="dv">1</span>]], <span class="at">weights =</span> <span class="cn">NULL</span>, <span class="at">normalized=</span><span class="cn">TRUE</span>, <span class="at">directed =</span> <span class="cn">FALSE</span>)</span>
<span id="cb20-2"><a href="#cb20-2" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb20-3"><a href="#cb20-3" aria-hidden="true" tabindex="-1"></a><span class="fu">closeness</span>(Mes_composantes[[<span class="dv">1</span>]], <span class="at">weights =</span> <span class="cn">NULL</span>, <span class="at">normalized=</span><span class="cn">TRUE</span>, <span class="at">mode =</span> <span class="st">"all"</span>)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
</div>
<p><br>
</p>
<p><strong>B.</strong> Mesurer la centralité d’un ou de plusieurs sommets en particulier.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb21"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb21-1"><a href="#cb21-1" aria-hidden="true" tabindex="-1"></a><span class="co"># Par l'index</span></span>
<span id="cb21-2"><a href="#cb21-2" aria-hidden="true" tabindex="-1"></a><span class="fu">degree</span>(karate)[<span class="dv">1</span>]</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>Mr Hi 
   16 </code></pre>
</div>
<div class="sourceCode cell-code" id="cb23"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb23-1"><a href="#cb23-1" aria-hidden="true" tabindex="-1"></a><span class="co"># Par le nom du sommet </span></span>
<span id="cb23-2"><a href="#cb23-2" aria-hidden="true" tabindex="-1"></a><span class="fu">betweenness</span>(karate, <span class="at">weights=</span><span class="cn">NULL</span>, <span class="at">normalized=</span><span class="cn">TRUE</span>)[<span class="st">"Mr Hi"</span>]</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>    Mr Hi 
0.4737689 </code></pre>
</div>
<div class="sourceCode cell-code" id="cb25"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb25-1"><a href="#cb25-1" aria-hidden="true" tabindex="-1"></a><span class="co"># Sélection multiple</span></span>
<span id="cb25-2"><a href="#cb25-2" aria-hidden="true" tabindex="-1"></a><span class="fu">closeness</span>(karate, <span class="at">weights=</span><span class="cn">NULL</span>, <span class="at">normalized=</span><span class="cn">TRUE</span>)[<span class="fu">c</span>(<span class="dv">1</span>,<span class="dv">34</span>)]</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>    Mr Hi    John A 
0.2538462 0.2519084 </code></pre>
</div>
</div>
</div>
</div>
</div>
<p><br>
</p>
</section>
<section id="transitivité-locale" class="level2" data-number="3.6">
<h2 data-number="3.6" class="anchored" data-anchor-id="transitivité-locale"><span class="header-section-number">3.6</span> Transitivité locale</h2>
<p>Mesurer la <code>transitivity()</code> locale (par sommet) avec l’argument <code>type</code>.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb27"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb27-1"><a href="#cb27-1" aria-hidden="true" tabindex="-1"></a><span class="fu">transitivity</span>(karate, <span class="at">type =</span> <span class="fu">c</span>(<span class="st">"local"</span>))</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>    Mr Hi   Actor 2   Actor 3   Actor 4   Actor 5   Actor 6   Actor 7   Actor 8 
0.1500000 0.3333333 0.2444444 0.6666667 0.6666667 0.5000000 0.5000000 1.0000000 
  Actor 9  Actor 10  Actor 11  Actor 12  Actor 13  Actor 14  Actor 15  Actor 16 
0.5000000 0.0000000 0.6666667       NaN 1.0000000 0.6000000 1.0000000 1.0000000 
 Actor 17  Actor 18  Actor 19  Actor 20  Actor 21  Actor 22  Actor 23  Actor 24 
1.0000000 1.0000000 1.0000000 0.3333333 1.0000000 1.0000000 1.0000000 0.4000000 
 Actor 25  Actor 26  Actor 27  Actor 28  Actor 29  Actor 30  Actor 31  Actor 32 
0.3333333 0.3333333 1.0000000 0.1666667 0.3333333 0.6666667 0.5000000 0.2000000 
 Actor 33    John A 
0.1969697 0.1102941 </code></pre>
</div>
</div>
<div class="callout callout-style-simple callout-note no-icon">
<div class="callout-body d-flex">
<div class="callout-icon-container">
<i class="callout-icon no-icon"></i>
</div>
<div class="callout-body-container">
<p>Il n’est pas possible de calculer la transitivité pour les sommets de degré inférieur à deux : par définition, ils ne sont membres d’aucune triade. La fonction renvoie alors la valeur ‘<strong>NaN</strong>’ (<strong>N</strong>ot <strong>a</strong> <strong>N</strong>umber).</p>
</div>
</div>
</div>
<p><br>
</p>
</section>
<section id="relations-entre-indicateurs" class="level2" data-number="3.7">
<h2 data-number="3.7" class="anchored" data-anchor-id="relations-entre-indicateurs"><span class="header-section-number">3.7</span> Relations entre indicateurs</h2>
<p>La fonction <code>plot()</code> permet de visualiser la relation entre deux indicateurs de centralité. Si le graphique suggère une relation linéaire, on peut utiliser la fonction <code>cor.test</code> (corrélation).</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb29"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb29-1"><a href="#cb29-1" aria-hidden="true" tabindex="-1"></a>degre <span class="ot">&lt;-</span> <span class="fu">degree</span>(karate)</span>
<span id="cb29-2"><a href="#cb29-2" aria-hidden="true" tabindex="-1"></a>inter <span class="ot">&lt;-</span> <span class="fu">betweenness</span>(karate)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
</div>
<p>Représentation graphique.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb30"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb30-1"><a href="#cb30-1" aria-hidden="true" tabindex="-1"></a><span class="co"># Représentation graphique</span></span>
<span id="cb30-2"><a href="#cb30-2" aria-hidden="true" tabindex="-1"></a><span class="fu">plot</span>(<span class="at">x =</span> degre, <span class="at">y =</span> inter)</span>
<span id="cb30-3"><a href="#cb30-3" aria-hidden="true" tabindex="-1"></a><span class="fu">text</span>(degre, inter, <span class="at">labels =</span> <span class="fu">V</span>(karate)<span class="sc">$</span>name,<span class="at">cex =</span> <span class="fl">0.7</span>, <span class="at">pos =</span> <span class="dv">2</span>)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output-display">
<div>
<figure class="figure">
<p><img src="mesures_files/figure-html/unnamed-chunk-16-1.png" class="img-fluid figure-img" width="672"></p>
</figure>
</div>
</div>
</div>
<p>Mesure de la corrélation avec <code>cor.test()</code>.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb31"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb31-1"><a href="#cb31-1" aria-hidden="true" tabindex="-1"></a><span class="co"># Méthode Pearson par défaut</span></span>
<span id="cb31-2"><a href="#cb31-2" aria-hidden="true" tabindex="-1"></a><span class="fu">cor.test</span>(degre, inter)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>
    Pearson's product-moment correlation

data:  degre and inter
t = 7.2451, df = 32, p-value = 3.128e-08
alternative hypothesis: true correlation is not equal to 0
95 percent confidence interval:
 0.6135820 0.8893245
sample estimates:
      cor 
0.7882018 </code></pre>
</div>
</div>
<p><strong>t</strong> : valeur de la statistique<br>
<strong>df</strong> : degrés de liberté<br>
<strong>p-value</strong> : p-value<br>
<strong>cor</strong> : coefficient de corrélation (de Pearson dans ce cas).</p>
<p><br>
</p>
</section>
<section id="les-mesures-comme-attributs" class="level2" data-number="3.8">
<h2 data-number="3.8" class="anchored" data-anchor-id="les-mesures-comme-attributs"><span class="header-section-number">3.8</span> Les mesures comme attributs</h2>
<p>Il est possible de transformer les différentes mesures en attributs des sommets et/ou des liens.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb33"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb33-1"><a href="#cb33-1" aria-hidden="true" tabindex="-1"></a><span class="co"># Centralité de degré</span></span>
<span id="cb33-2"><a href="#cb33-2" aria-hidden="true" tabindex="-1"></a><span class="fu">V</span>(karate)<span class="sc">$</span>degre <span class="ot">&lt;-</span> <span class="fu">degree</span>(karate)</span>
<span id="cb33-3"><a href="#cb33-3" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb33-4"><a href="#cb33-4" aria-hidden="true" tabindex="-1"></a><span class="co"># Centralité d'intermediarité</span></span>
<span id="cb33-5"><a href="#cb33-5" aria-hidden="true" tabindex="-1"></a><span class="fu">V</span>(karate)<span class="sc">$</span>intermed <span class="ot">&lt;-</span> <span class="fu">betweenness</span>(karate, <span class="at">weights=</span><span class="cn">NULL</span>, <span class="at">normalized=</span><span class="cn">TRUE</span>)</span>
<span id="cb33-6"><a href="#cb33-6" aria-hidden="true" tabindex="-1"></a>  </span>
<span id="cb33-7"><a href="#cb33-7" aria-hidden="true" tabindex="-1"></a><span class="co"># Centralité de proximité</span></span>
<span id="cb33-8"><a href="#cb33-8" aria-hidden="true" tabindex="-1"></a><span class="fu">V</span>(karate)<span class="sc">$</span>proximit <span class="ot">&lt;-</span> <span class="fu">closeness</span>(karate, <span class="at">weights=</span><span class="cn">NULL</span>, <span class="at">normalized=</span><span class="cn">TRUE</span>)</span>
<span id="cb33-9"><a href="#cb33-9" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb33-10"><a href="#cb33-10" aria-hidden="true" tabindex="-1"></a><span class="co"># Transitivité locale</span></span>
<span id="cb33-11"><a href="#cb33-11" aria-hidden="true" tabindex="-1"></a><span class="fu">V</span>(karate)<span class="sc">$</span>transit_loc <span class="ot">&lt;-</span> <span class="fu">transitivity</span>(karate, <span class="at">type =</span> <span class="fu">c</span>(<span class="st">"local"</span>))</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
</div>
<p>Les sommets ont de nouveaux attributs.</p>
<div class="cell">
<div class="cell-output-display">
<div class="datatables html-widget html-fill-item" id="htmlwidget-6254af280d66ddba9515" style="width:100%;height:auto;"></div>
<script type="application/json" data-for="htmlwidget-6254af280d66ddba9515">{"x":{"filter":"none","vertical":false,"data":[["Mr Hi","Actor 2","Actor 3","Actor 4","Actor 5","Actor 6","Actor 7","Actor 8","Actor 9","Actor 10","Actor 11","Actor 12","Actor 13","Actor 14","Actor 15","Actor 16","Actor 17","Actor 18","Actor 19","Actor 20","Actor 21","Actor 22","Actor 23","Actor 24","Actor 25","Actor 26","Actor 27","Actor 28","Actor 29","Actor 30","Actor 31","Actor 32","Actor 33","John A"],[1,1,1,1,1,1,1,1,2,2,1,1,1,1,2,2,1,1,2,1,2,1,2,2,2,2,2,2,2,2,2,2,2,2],["Mr Hi","Actor 2","Actor 3","Actor 4","Actor 5","Actor 6","Actor 7","Actor 8","Actor 9","Actor 10","Actor 11","Actor 12","Actor 13","Actor 14","Actor 15","Actor 16","Actor 17","Actor 18","Actor 19","Actor 20","Actor 21","Actor 22","Actor 23","Actor 24","Actor 25","Actor 26","Actor 27","Actor 28","Actor 29","Actor 30","Actor 31","Actor 32","Actor 33","John A"],["H","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26","27","28","29","30","31","32","33","A"],[1,1,1,1,1,1,1,1,2,2,1,1,1,1,2,2,1,1,2,1,2,1,2,2,2,2,2,2,2,2,2,2,2,2],[16,9,10,6,3,4,4,4,5,2,3,1,2,5,2,2,2,2,2,3,2,2,2,5,3,3,2,4,3,4,4,6,12,17],[0.4737689393939393,0.06401515151515152,0.0694128787878788,0.002525252525252525,0.000946969696969697,0.02935606060606061,0.02935606060606061,0,0.02481060606060606,0.01379419191919192,0.000946969696969697,0,0,0.002272727272727273,0,0,0,0.03049242424242424,0.005681818181818182,0.2406565656565657,0,0,0,0.001893939393939394,0.06407828282828282,0.000946969696969697,0,0.01231060606060606,0.01912878787878788,0,0.005681818181818182,0.1256313131313131,0.07222222222222222,0.3967803030303029],[0.2538461538461538,0.2,0.1964285714285714,0.1764705882352941,0.1527777777777778,0.152073732718894,0.1534883720930233,0.1823204419889503,0.1987951807228916,0.1907514450867052,0.175531914893617,0.1460176991150443,0.2049689440993789,0.1907514450867052,0.1709844559585492,0.1375,0.1085526315789474,0.1929824561403509,0.1875,0.2481203007518797,0.2037037037037037,0.1764705882352941,0.1586538461538461,0.138655462184874,0.1578947368421053,0.1235955056179775,0.1692307692307692,0.1563981042654028,0.2024539877300613,0.1746031746031746,0.1736842105263158,0.2088607594936709,0.2,0.2519083969465649],[0.15,0.3333333333333333,0.2444444444444445,0.6666666666666667,0.6666666666666666,0.5,0.5,1,0.5,0,0.6666666666666666,null,1,0.6,1,1,1,1,1,0.3333333333333333,1,1,1,0.4,0.3333333333333333,0.3333333333333333,1,0.1666666666666667,0.3333333333333333,0.6666666666666666,0.5,0.2,0.196969696969697,0.1102941176470588]],"container":"<table class=\"cell-border stripe\">\n  <thead>\n    <tr>\n      <th> <\/th>\n      <th>Faction<\/th>\n      <th>name<\/th>\n      <th>label<\/th>\n      <th>color<\/th>\n      <th>degre<\/th>\n      <th>intermed<\/th>\n      <th>proximit<\/th>\n      <th>transit_loc<\/th>\n    <\/tr>\n  <\/thead>\n<\/table>","options":{"pageLength":5,"columnDefs":[{"className":"dt-right","targets":[1,4,5,6,7,8]},{"orderable":false,"targets":0},{"name":" ","targets":0},{"name":"Faction","targets":1},{"name":"name","targets":2},{"name":"label","targets":3},{"name":"color","targets":4},{"name":"degre","targets":5},{"name":"intermed","targets":6},{"name":"proximit","targets":7},{"name":"transit_loc","targets":8}],"order":[],"autoWidth":false,"orderClasses":false,"lengthMenu":[5,10,25,50,100]}},"evals":[],"jsHooks":[]}</script>
</div>
</div>
<p><br>
</p>


</section>

</main> <!-- /main -->
<script id="quarto-html-after-body" type="application/javascript">
window.document.addEventListener("DOMContentLoaded", function (event) {
  const toggleBodyColorMode = (bsSheetEl) => {
    const mode = bsSheetEl.getAttribute("data-mode");
    const bodyEl = window.document.querySelector("body");
    if (mode === "dark") {
      bodyEl.classList.add("quarto-dark");
      bodyEl.classList.remove("quarto-light");
    } else {
      bodyEl.classList.add("quarto-light");
      bodyEl.classList.remove("quarto-dark");
    }
  }
  const toggleBodyColorPrimary = () => {
    const bsSheetEl = window.document.querySelector("link#quarto-bootstrap");
    if (bsSheetEl) {
      toggleBodyColorMode(bsSheetEl);
    }
  }
  toggleBodyColorPrimary();  
  const icon = "";
  const anchorJS = new window.AnchorJS();
  anchorJS.options = {
    placement: 'right',
    icon: icon
  };
  anchorJS.add('.anchored');
  const isCodeAnnotation = (el) => {
    for (const clz of el.classList) {
      if (clz.startsWith('code-annotation-')) {                     
        return true;
      }
    }
    return false;
  }
  const onCopySuccess = function(e) {
    // button target
    const button = e.trigger;
    // don't keep focus
    button.blur();
    // flash "checked"
    button.classList.add('code-copy-button-checked');
    var currentTitle = button.getAttribute("title");
    button.setAttribute("title", "Copié");
    let tooltip;
    if (window.bootstrap) {
      button.setAttribute("data-bs-toggle", "tooltip");
      button.setAttribute("data-bs-placement", "left");
      button.setAttribute("data-bs-title", "Copié");
      tooltip = new bootstrap.Tooltip(button, 
        { trigger: "manual", 
          customClass: "code-copy-button-tooltip",
          offset: [0, -8]});
      tooltip.show();    
    }
    setTimeout(function() {
      if (tooltip) {
        tooltip.hide();
        button.removeAttribute("data-bs-title");
        button.removeAttribute("data-bs-toggle");
        button.removeAttribute("data-bs-placement");
      }
      button.setAttribute("title", currentTitle);
      button.classList.remove('code-copy-button-checked');
    }, 1000);
    // clear code selection
    e.clearSelection();
  }
  const getTextToCopy = function(trigger) {
      const codeEl = trigger.previousElementSibling.cloneNode(true);
      for (const childEl of codeEl.children) {
        if (isCodeAnnotation(childEl)) {
          childEl.remove();
        }
      }
      return codeEl.innerText;
  }
  const clipboard = new window.ClipboardJS('.code-copy-button:not([data-in-quarto-modal])', {
    text: getTextToCopy
  });
  clipboard.on('success', onCopySuccess);
  if (window.document.getElementById('quarto-embedded-source-code-modal')) {
    // For code content inside modals, clipBoardJS needs to be initialized with a container option
    // TODO: Check when it could be a function (https://github.com/zenorocha/clipboard.js/issues/860)
    const clipboardModal = new window.ClipboardJS('.code-copy-button[data-in-quarto-modal]', {
      text: getTextToCopy,
      container: window.document.getElementById('quarto-embedded-source-code-modal')
    });
    clipboardModal.on('success', onCopySuccess);
  }
    var localhostRegex = new RegExp(/^(?:http|https):\/\/localhost\:?[0-9]*\//);
    var mailtoRegex = new RegExp(/^mailto:/);
      var filterRegex = new RegExp('/' + window.location.host + '/');
    var isInternal = (href) => {
        return filterRegex.test(href) || localhostRegex.test(href) || mailtoRegex.test(href);
    }
    // Inspect non-navigation links and adorn them if external
 	var links = window.document.querySelectorAll('a[href]:not(.nav-link):not(.navbar-brand):not(.toc-action):not(.sidebar-link):not(.sidebar-item-toggle):not(.pagination-link):not(.no-external):not([aria-hidden]):not(.dropdown-item):not(.quarto-navigation-tool):not(.about-link)');
    for (var i=0; i<links.length; i++) {
      const link = links[i];
      if (!isInternal(link.href)) {
        // undo the damage that might have been done by quarto-nav.js in the case of
        // links that we want to consider external
        if (link.dataset.originalHref !== undefined) {
          link.href = link.dataset.originalHref;
        }
      }
    }
  function tippyHover(el, contentFn, onTriggerFn, onUntriggerFn) {
    const config = {
      allowHTML: true,
      maxWidth: 500,
      delay: 100,
      arrow: false,
      appendTo: function(el) {
          return el.parentElement;
      },
      interactive: true,
      interactiveBorder: 10,
      theme: 'quarto',
      placement: 'bottom-start',
    };
    if (contentFn) {
      config.content = contentFn;
    }
    if (onTriggerFn) {
      config.onTrigger = onTriggerFn;
    }
    if (onUntriggerFn) {
      config.onUntrigger = onUntriggerFn;
    }
    window.tippy(el, config); 
  }
  const noterefs = window.document.querySelectorAll('a[role="doc-noteref"]');
  for (var i=0; i<noterefs.length; i++) {
    const ref = noterefs[i];
    tippyHover(ref, function() {
      // use id or data attribute instead here
      let href = ref.getAttribute('data-footnote-href') || ref.getAttribute('href');
      try { href = new URL(href).hash; } catch {}
      const id = href.replace(/^#\/?/, "");
      const note = window.document.getElementById(id);
      if (note) {
        return note.innerHTML;
      } else {
        return "";
      }
    });
  }
  const xrefs = window.document.querySelectorAll('a.quarto-xref');
  const processXRef = (id, note) => {
    // Strip column container classes
    const stripColumnClz = (el) => {
      el.classList.remove("page-full", "page-columns");
      if (el.children) {
        for (const child of el.children) {
          stripColumnClz(child);
        }
      }
    }
    stripColumnClz(note)
    if (id === null || id.startsWith('sec-')) {
      // Special case sections, only their first couple elements
      const container = document.createElement("div");
      if (note.children && note.children.length > 2) {
        container.appendChild(note.children[0].cloneNode(true));
        for (let i = 1; i < note.children.length; i++) {
          const child = note.children[i];
          if (child.tagName === "P" && child.innerText === "") {
            continue;
          } else {
            container.appendChild(child.cloneNode(true));
            break;
          }
        }
        if (window.Quarto?.typesetMath) {
          window.Quarto.typesetMath(container);
        }
        return container.innerHTML
      } else {
        if (window.Quarto?.typesetMath) {
          window.Quarto.typesetMath(note);
        }
        return note.innerHTML;
      }
    } else {
      // Remove any anchor links if they are present
      const anchorLink = note.querySelector('a.anchorjs-link');
      if (anchorLink) {
        anchorLink.remove();
      }
      if (window.Quarto?.typesetMath) {
        window.Quarto.typesetMath(note);
      }
      // TODO in 1.5, we should make sure this works without a callout special case
      if (note.classList.contains("callout")) {
        return note.outerHTML;
      } else {
        return note.innerHTML;
      }
    }
  }
  for (var i=0; i<xrefs.length; i++) {
    const xref = xrefs[i];
    tippyHover(xref, undefined, function(instance) {
      instance.disable();
      let url = xref.getAttribute('href');
      let hash = undefined; 
      if (url.startsWith('#')) {
        hash = url;
      } else {
        try { hash = new URL(url).hash; } catch {}
      }
      if (hash) {
        const id = hash.replace(/^#\/?/, "");
        const note = window.document.getElementById(id);
        if (note !== null) {
          try {
            const html = processXRef(id, note.cloneNode(true));
            instance.setContent(html);
          } finally {
            instance.enable();
            instance.show();
          }
        } else {
          // See if we can fetch this
          fetch(url.split('#')[0])
          .then(res => res.text())
          .then(html => {
            const parser = new DOMParser();
            const htmlDoc = parser.parseFromString(html, "text/html");
            const note = htmlDoc.getElementById(id);
            if (note !== null) {
              const html = processXRef(id, note);
              instance.setContent(html);
            } 
          }).finally(() => {
            instance.enable();
            instance.show();
          });
        }
      } else {
        // See if we can fetch a full url (with no hash to target)
        // This is a special case and we should probably do some content thinning / targeting
        fetch(url)
        .then(res => res.text())
        .then(html => {
          const parser = new DOMParser();
          const htmlDoc = parser.parseFromString(html, "text/html");
          const note = htmlDoc.querySelector('main.content');
          if (note !== null) {
            // This should only happen for chapter cross references
            // (since there is no id in the URL)
            // remove the first header
            if (note.children.length > 0 && note.children[0].tagName === "HEADER") {
              note.children[0].remove();
            }
            const html = processXRef(null, note);
            instance.setContent(html);
          } 
        }).finally(() => {
          instance.enable();
          instance.show();
        });
      }
    }, function(instance) {
    });
  }
      let selectedAnnoteEl;
      const selectorForAnnotation = ( cell, annotation) => {
        let cellAttr = 'data-code-cell="' + cell + '"';
        let lineAttr = 'data-code-annotation="' +  annotation + '"';
        const selector = 'span[' + cellAttr + '][' + lineAttr + ']';
        return selector;
      }
      const selectCodeLines = (annoteEl) => {
        const doc = window.document;
        const targetCell = annoteEl.getAttribute("data-target-cell");
        const targetAnnotation = annoteEl.getAttribute("data-target-annotation");
        const annoteSpan = window.document.querySelector(selectorForAnnotation(targetCell, targetAnnotation));
        const lines = annoteSpan.getAttribute("data-code-lines").split(",");
        const lineIds = lines.map((line) => {
          return targetCell + "-" + line;
        })
        let top = null;
        let height = null;
        let parent = null;
        if (lineIds.length > 0) {
            //compute the position of the single el (top and bottom and make a div)
            const el = window.document.getElementById(lineIds[0]);
            top = el.offsetTop;
            height = el.offsetHeight;
            parent = el.parentElement.parentElement;
          if (lineIds.length > 1) {
            const lastEl = window.document.getElementById(lineIds[lineIds.length - 1]);
            const bottom = lastEl.offsetTop + lastEl.offsetHeight;
            height = bottom - top;
          }
          if (top !== null && height !== null && parent !== null) {
            // cook up a div (if necessary) and position it 
            let div = window.document.getElementById("code-annotation-line-highlight");
            if (div === null) {
              div = window.document.createElement("div");
              div.setAttribute("id", "code-annotation-line-highlight");
              div.style.position = 'absolute';
              parent.appendChild(div);
            }
            div.style.top = top - 2 + "px";
            div.style.height = height + 4 + "px";
            div.style.left = 0;
            let gutterDiv = window.document.getElementById("code-annotation-line-highlight-gutter");
            if (gutterDiv === null) {
              gutterDiv = window.document.createElement("div");
              gutterDiv.setAttribute("id", "code-annotation-line-highlight-gutter");
              gutterDiv.style.position = 'absolute';
              const codeCell = window.document.getElementById(targetCell);
              const gutter = codeCell.querySelector('.code-annotation-gutter');
              gutter.appendChild(gutterDiv);
            }
            gutterDiv.style.top = top - 2 + "px";
            gutterDiv.style.height = height + 4 + "px";
          }
          selectedAnnoteEl = annoteEl;
        }
      };
      const unselectCodeLines = () => {
        const elementsIds = ["code-annotation-line-highlight", "code-annotation-line-highlight-gutter"];
        elementsIds.forEach((elId) => {
          const div = window.document.getElementById(elId);
          if (div) {
            div.remove();
          }
        });
        selectedAnnoteEl = undefined;
      };
        // Handle positioning of the toggle
    window.addEventListener(
      "resize",
      throttle(() => {
        elRect = undefined;
        if (selectedAnnoteEl) {
          selectCodeLines(selectedAnnoteEl);
        }
      }, 10)
    );
    function throttle(fn, ms) {
    let throttle = false;
    let timer;
      return (...args) => {
        if(!throttle) { // first call gets through
            fn.apply(this, args);
            throttle = true;
        } else { // all the others get throttled
            if(timer) clearTimeout(timer); // cancel #2
            timer = setTimeout(() => {
              fn.apply(this, args);
              timer = throttle = false;
            }, ms);
        }
      };
    }
      // Attach click handler to the DT
      const annoteDls = window.document.querySelectorAll('dt[data-target-cell]');
      for (const annoteDlNode of annoteDls) {
        annoteDlNode.addEventListener('click', (event) => {
          const clickedEl = event.target;
          if (clickedEl !== selectedAnnoteEl) {
            unselectCodeLines();
            const activeEl = window.document.querySelector('dt[data-target-cell].code-annotation-active');
            if (activeEl) {
              activeEl.classList.remove('code-annotation-active');
            }
            selectCodeLines(clickedEl);
            clickedEl.classList.add('code-annotation-active');
          } else {
            // Unselect the line
            unselectCodeLines();
            clickedEl.classList.remove('code-annotation-active');
          }
        });
      }
  const findCites = (el) => {
    const parentEl = el.parentElement;
    if (parentEl) {
      const cites = parentEl.dataset.cites;
      if (cites) {
        return {
          el,
          cites: cites.split(' ')
        };
      } else {
        return findCites(el.parentElement)
      }
    } else {
      return undefined;
    }
  };
  var bibliorefs = window.document.querySelectorAll('a[role="doc-biblioref"]');
  for (var i=0; i<bibliorefs.length; i++) {
    const ref = bibliorefs[i];
    const citeInfo = findCites(ref);
    if (citeInfo) {
      tippyHover(citeInfo.el, function() {
        var popup = window.document.createElement('div');
        citeInfo.cites.forEach(function(cite) {
          var citeDiv = window.document.createElement('div');
          citeDiv.classList.add('hanging-indent');
          citeDiv.classList.add('csl-entry');
          var biblioDiv = window.document.getElementById('ref-' + cite);
          if (biblioDiv) {
            citeDiv.innerHTML = biblioDiv.innerHTML;
          }
          popup.appendChild(citeDiv);
        });
        return popup.innerHTML;
      });
    }
  }
});
</script>
<nav class="page-navigation">
  <div class="nav-page nav-page-previous">
      <a href="./indicateurs.html" class="pagination-link" aria-label="Indicateurs globaux">
        <i class="bi bi-arrow-left-short"></i> <span class="nav-page-text"><span class="chapter-number">2</span>&nbsp; <span class="chapter-title">Indicateurs globaux</span></span>
      </a>          
  </div>
  <div class="nav-page nav-page-next">
      <a href="./communaute.html" class="pagination-link" aria-label="Cliques et communautés">
        <span class="nav-page-text"><span class="chapter-number">4</span>&nbsp; <span class="chapter-title">Cliques et communautés</span></span> <i class="bi bi-arrow-right-short"></i>
      </a>
  </div>
</nav>
</div> <!-- /content -->
<footer class="footer">
  <div class="nav-footer">
    <div class="nav-footer-left">
<div class="quarto-figure quarto-figure-center">
<figure class="figure">
<p><a href="https://creativecommons.org/licenses/by-nc-sa/4.0/"><img src="img/by-nc-sa.png" class="img-fluid figure-img" alt="CreativeCommonsLicense"></a></p>
<figcaption>CreativeCommonsLicense</figcaption>
</figure>
</div>
</div>   
    <div class="nav-footer-center">
      &nbsp;
    </div>
    <div class="nav-footer-right">
      &nbsp;
    </div>
  </div>
</footer>




</body></html>